#version 120

varying vec4 color;
varying vec2 textureCoord;
uniform sampler2D sampler0;

uniform float hue = 0.5;
uniform float amount = 0.0;

uniform float time;

//from https://github.com/jamieowen/glsl-blend/blob/master/overlay.glsl

vec3 hsv2rgb(vec3 c) {
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

float blendOverlay(float base, float blend) {
	return base<0.5?(2.0*base*blend):(1.0-2.0*(1.0-base)*(1.0-blend));
}

vec3 blendOverlay(vec3 base, vec3 blend) {
	return vec3(blendOverlay(base.r,blend.r),blendOverlay(base.g,blend.g),blendOverlay(base.b,blend.b));
}

vec3 blendOverlay(vec3 base, vec3 blend, float opacity) {
	return (blendOverlay(base, blend) * opacity + base * (1.0 - opacity));
}


void main()
{
	vec3 col = texture2D( sampler0, textureCoord ).rgb;

	vec3 tint = hsv2rgb(vec3(hue,1,1));

	gl_FragColor = vec4( blendOverlay(col,tint,amount), 1.0 ) * color;
}
