#version 120

// from https://stackoverflow.com/questions/13739901/vertex-kaleidoscope-shader

uniform float multiply=8.0;
uniform float offset=0.0;
uniform float shift=0.0;

varying vec4 color;
varying vec2 imageCoord;
uniform vec2 textureSize;
uniform vec2 imageSize;
uniform sampler2D sampler0;

uniform float time;

vec3 hueShift(vec3 col, float hue) {
    const vec3 k = vec3(0.57735, 0.57735, 0.57735);
    float cosAngle = cos(hue);
    return vec3(col * cosAngle + cross(k, col) * sin(hue) + k * dot(k, col) * (1.0 - cosAngle));
}

void main()
{
	vec2 uv = imageCoord;
	vec2 pos = uv - 0.5;

	float r = length(pos);
    float a = atan(pos.y, pos.x);
    float sides = multiply;
    float tau = 2.0 * 3.1416;
    a = mod(a, tau/sides);
    a = abs(a - tau/sides/2.0);
    vec2 position = r * vec2(cos(a), sin(a)) + 0.5 + time*0.05 + offset;

	uv = mod( position , 1.0 ) / textureSize * imageSize;

	gl_FragColor = vec4(hueShift(vec3(texture2D( sampler0, uv ) * color), shift), color[3]);
}